<template>
  <crud-data-table-form-dialog
    v-model="dialog"
    :loading="isLoading"
    :activator="false"
    :dialog-title="$t('dialogTitle')"
    :dialog-subtitle="$t('dialogSubtitle')"
    :max-width="null"
    fullscreen
    @onClose="onCloseDialog"
    @onSave="onSave"
  >
    <expense-form
      v-model="form"
      :is-loading="isLoading"
      :installment-template="INSTALLMENT_TEMPLATE"
      is-edit
      @formRef="formRef = $event"
      @installmentsReset="installmentsResetCallback = $event"
    />
  </crud-data-table-form-dialog>
</template>

<script>
  import { cloneDeep } from 'lodash'
  import ExpenseForm from '../Form'

  const INSTALLMENT_TEMPLATE = {
    referenceMonth: '',
    amount: '',
    dueDate: '',
    paidOutAt: '',
  }
  const getFormInitialState = () => {
    return {
      id: '',
      purchaseDate: '',
      categoryId: '',
      paymentStatusId: '',
      paymentRecurrenceId: '',
      paymentMethodId: '',
      companyNickname: '',
      description: '',
      numberOfInstallments: '',
      installments: [{
        id: 1,
      }],
    }
  }

  export default {
    name: 'UpdateExpenseDialog',
    components: {
      ExpenseForm,
    },
    data () {
      return {
        dialog: false,
        isLoading: false,
        form: getFormInitialState(),
        formRef: null,
        INSTALLMENT_TEMPLATE,
        installmentsResetCallback: null,
      }
    },
    created () {
      this.$emit('openDialog', this.openDialog)
    },
    methods: {
      closeDialogAndCleanForm () {
        this.closeDialog()
        this.formRef.reset()
        this.installmentsResetCallback()
      },
      onCloseDialog () {
        this.closeDialogAndCleanForm()
      },
      removeUnusedKeysFromFormInstallments () {
        return this.form.installments.map(installment => {
          if (installment.new) {
            delete installment.id
            delete installment.new
          }
          return installment
        })
      },
      onSave () {
        if (this.formRef.validate()) {
          this.isLoading = true
          this.form.installments = this.removeUnusedKeysFromFormInstallments()
          this.$store.dispatch('expenses/updateExpense', {
            form: this.form,
          })
            .then(() => {
              this.closeDialogAndCleanForm()
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('updateError'),
              })
            })
            .finally(() => {
              this.isLoading = false
              this.closeDialog()
            })
        }
      },
      openDialog (expense) {
        this.dialog = true
        this.form = cloneDeep(expense)
      },
      closeDialog () {
        this.dialog = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          dialogTitle: 'Atualização de despesa',
          dialogSubtitle: 'Os campos marcados com o asterísco (*) são obrigatórios.',
          updateSuccess: 'Despesa atualizada com sucesso!',
          updateError: 'Ops... Algo deu errado ao tentar atualizar a despesa. Por favor, tente novamente.',
        },
        'en-US': {
          dialogTitle: 'Expense update',
          dialogSubtitle: 'Fields marked with an asterisk (*) are required.',
          updateSuccess: 'Expense successfully updated!',
          updateError: 'Oops... Something went wrong while trying to update the expense. Please try again.',
        },
      },
    },
  }
</script>
